package com.ruoyi.business.service.impl;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.ruoyi.business.domain.Rebot;
import com.ruoyi.business.domain.bo.ListApplyBO;
import com.ruoyi.business.domain.bo.ListRebotBO;
import com.ruoyi.business.domain.vo.ListApplyVO;
import com.ruoyi.business.domain.vo.ListRebotVO;
import com.ruoyi.business.util.YinDaoHttpUtils;
import com.ruoyi.common.annotation.DataScope;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.common.utils.bean.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.business.mapper.ApplyMapper;
import com.ruoyi.business.domain.Apply;
import com.ruoyi.business.service.IApplyService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.transaction.annotation.Transactional;

/**
 * 应用信息管理Service业务层处理
 * 
 * @author LiuChengRan
 * @date 2024-06-13
 */
@Service
public class ApplyServiceImpl extends ServiceImpl<ApplyMapper, Apply> implements IApplyService
{


    /**
     * 同步机器人数据
     *
     * @return
     */
    @Override
    @DataScope(deptAlias = "d", userAlias = "u")
    @Transactional
    public void syn(Apply entity) {
        ListApplyBO listApplyBO = new ListApplyBO();
        listApplyBO.setPage(1);
        listApplyBO.setSize(10000);
        List<Apply> applyList = baseMapper.selectApplyList(new Apply());
        Map<String, List<Apply>> applyMap = applyList.stream().collect(Collectors.groupingBy(Apply::getAppId));

        List<ListApplyVO> listApplyVOList = YinDaoHttpUtils.listApp(listApplyBO);
        // 获取客户端名称集合
        List<String> appIdList = listApplyVOList.stream().map(ListApplyVO::getAppId).collect(Collectors.toList());
        this.remove(new LambdaUpdateWrapper<Apply>().notIn(Apply::getAppId, appIdList).eq(Apply::getDeptId, SecurityUtils.getDeptId()));
        listApplyVOList.forEach(listRebotVO -> {
            // 数据库里是否存在
            List<Apply> applys = applyMap.get(listRebotVO.getAppId());
            if (null == applys) {
                Apply newApply = new Apply();
                BeanUtils.copyBeanProp(newApply, listRebotVO);
                newApply.setAppCreateTime(listRebotVO.getAppCreateTime());
                newApply.setAppUpdateTime(listRebotVO.getAppUpdateTime());
                newApply.setDeptId(SecurityUtils.getDeptId());
                save(newApply);
            } else {
                Apply apply = applys.get(0);
                Apply newApply =new Apply();
                BeanUtils.copyBeanProp(newApply, listRebotVO);
                newApply.setAppCreateTime(listRebotVO.getAppCreateTime());
                newApply.setAppUpdateTime(listRebotVO.getAppUpdateTime());
                newApply.setId(apply.getId());
                newApply.setDeptId(SecurityUtils.getDeptId());
                updateById(newApply);
            }
        });
    }
    /**
     * 查询应用信息管理列表
     * 
     * @param apply 应用信息管理
     * @return 应用信息管理
     */
    @Override
    public List<Apply> list(Apply apply)
    {
        return baseMapper.selectApplyList(apply);
    }
}
